<?php
/**
 *
 * @author: xaboy<365615158@qq.com>
 * @day: 2018/3/3
 */

namespace app\models\user;

use crmeb\basic\BaseModel;
use crmeb\services\workerman\ChannelService;
use crmeb\traits\ModelTrait;
use think\facade\Config;

/**
 * TODO 用户提现
 * Class UserExtract
 * @package app\models\user
 */
class UserExtract extends BaseModel
{
    /**
     * 数据表主键
     * @var string
     */
    protected $pk = 'id';

    /**
     * 模型名称
     * @var string
     */
    protected $name = 'user_extract';

    use ModelTrait;

    protected static $extractType = ['alipay','bank','weixin'];

    protected static $extractTypeMsg = ['alipay'=>'支付宝','bank'=>'银行卡','weixin'=>'微信'];

    protected static $status = array(
        EXTRACT_FAILED   => '未通过',
        EXTRACT_AUDITING => '审核中',
        EXTRACT_SUC      => '已提现',
    );

    /**
     * 用户自主提现记录提现记录,后台执行审核
     * @param array $userInfo 用户个人信息
     * @param array $data 提现详细信息
     * @return bool
     */
    public static function userExtract($userInfo, $data){
        if(!in_array($data['extract_type'], self::$extractType)) {
            return self::setErrorInfo('提现方式不存在');
        }
            
        $userInfo = User::get($userInfo['uid']);
        $extractPrice = $userInfo['brokerage_price'];
        if($extractPrice < 0) {
            return self::setErrorInfo('提现佣金不足'.$data['money']);
        }
        if($data['money'] > $extractPrice) {
            return self::setErrorInfo('提现佣金不足'.$data['money']);
        }
        if($data['money'] <= 0) {
            return self::setErrorInfo('提现佣金大于0');
        }

        $balance = bcsub($userInfo['brokerage_price'],$data['money'],2);
        if($balance < 0) {
            $balance = 0;
        }
        $insertData = [
            'uid' => $userInfo['uid'],
            'extract_type' => $data['extract_type'],
            'extract_price' => $data['money'],
            'add_time' => time(),
            'balance' => $balance,
            'status' => EXTRACT_AUDITING,
        ];
        if(isset($data['name']) && strlen(trim($data['name']))) {
            $insertData['real_name'] = $data['name'];
        } else {
            $insertData['real_name'] = $userInfo['nickname'];
        }
        if(isset($data['cardnum'])) {
            $insertData['bank_code'] = $data['cardnum'];
        } else {
            $insertData['bank_code'] = '';
        }
        if(isset($data['bankname'])) {
            $insertData['bank_address']=$data['bankname'];
        } else {
            $insertData['bank_address']='';
        }
        if(isset($data['weixin'])) {
            $insertData['wechat'] = $data['weixin'];
        } else {
            $insertData['wechat'] = $userInfo['nickname'];
        }
        if($data['extract_type'] == 'alipay'){
            $enabled = Config::get('app.extract_alipay_enabled', false);
            if (!$enabled) {
                return self::setErrorInfo('支付宝提现已关闭');
            }

            if(!$data['alipay_code']) {
                return self::setErrorInfo('请输入支付宝账号');
            }
            $insertData['alipay_code'] = $data['alipay_code'];
            $mark = '使用支付宝提现'.$insertData['extract_price'].'元';
        }else if($data['extract_type'] == 'bank'){
            $enabled = Config::get('app.extract_bank_enabled', false);
            if (!$enabled) {
                return self::setErrorInfo('银行卡提现已关闭');
            }

            if(!$data['cardnum']) {
                return self::setErrorInfo('请输入银行卡账号');
            }
            if(!$data['bankname']) {
                return self::setErrorInfo('请输入开户行信息');
            }
            
            $mark = '使用银联卡'.$insertData['bank_code'].'提现'.$insertData['extract_price'].'元';
        }else if($data['extract_type'] == 'weixin'){
            $enabled = Config::get('app.extract_weixin_enabled', false);
            if (!$enabled) {
                return self::setErrorInfo('微信提现已关闭');
            }

            if(!$data['weixin']) {
                return self::setErrorInfo('请输入微信账号');
            }

            if ($insertData['extract_price'] > 200) {
                return self::setErrorInfo('微信提现每次不能大于200元');
            }

            $mark = '使用微信提现'.$insertData['extract_price'].'元';
        }
        
        self::beginTrans();
        try{
            $res1 = self::create($insertData);
            if(!$res1) {
                errlog('UserExtract.php line 101. insert failed.');
                return self::setErrorInfo('提现申请失败，请联系客服处理');
            }

            $res2 = User::edit(['brokerage_price'=>$balance],$userInfo['uid'],'uid');
            $res3 = UserBill::expend('余额提现',$userInfo['uid'],'now_money','extract',$data['money'],$res1['id'],$balance,$mark);
            $res = $res2 && $res3;
            if($res){
                try{
                    ChannelService::instance()->send('WITHDRAW', ['id'=>$res1->id]);
                }catch (\Exception $e){}
                event('AdminNewPush');
                event('UserRequestWithdrawal', ['user'=> $userInfo, 'info' => $insertData]);
                //发送模板消息
            } else {
                errlog('UserExtract.php sql failed. $res2=' . $res2 . ' $res3=' . $res3);
                self::rollbackTrans();
                return self::setErrorInfo('提现申请失败，请联系客服处理');
            }
            self::commitTrans();
            return $insertData;
        }catch (\Exception $e){
            errlog('UserExtract.php exception:' . $e->getMessage());
            self::rollbackTrans();
            return self::setErrorInfo('提现申请失败，请联系客服处理');
        }
    }

    /**
     * 获得用户最后一次提现信息
     * @param $openid
     * @return mixed
     */
    public static function userLastInfo($uid)
    {
        return self::where(compact('uid'))->order('add_time DESC')->find();
    }

    /**
     * 根据条件查找
     */
    public static function getUserExtractInfo($uid, $extract_type, $time, $status=EXTRACT_AUDITING)
    {
        $res = self::where('uid', $uid)
            ->where('extract_type', $extract_type)
            ->where('add_time', $time)
            ->where('status', $status)
            ->find();
        return $res;
    }

    /**
     * 获得用户提现总金额
     * @param $uid
     * @return mixed
     */
    public static function userExtractTotalPrice($uid, $status=EXTRACT_SUC)
    {
        return self::where('uid',$uid)->where('status',$status)->value('SUM(extract_price)')?:0;
    }

    /**
     * 用户提现记录列表
     * @param int $uid 用户uid
     * @param int $first 截取行数
     * @param int $limit 截取数
     * @return \think\Collection
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     */
    public static function extractList($uid,$first = 0,$limit = 8)
    {
        $list=UserExtract::where('uid',$uid)->order('add_time desc')->limit($first,$limit)->select();
        foreach($list as &$v){
            $v['add_time']=date('Y/m/d',$v['add_time']);
        }
        return $list;
    }

    /**
     * 获取累计已提现佣金
     * @param $uid
     * @return float
     */
    public static function extractSum($uid)
    {
        return self::where('uid',$uid)->where('status', EXTRACT_SUC)->sum('extract_price');
    }

}